package gregapi.render;

import static gregapi.data.CS.UNCOLOURED;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.util.IIcon;

/** 
 * @author Gregorius Techneticies
 */
public class BlockTextureCopied implements ITexture {
	private final Block mBlock;
	private final byte mSide, mMeta;
	
	/**
	 *  DO NOT MANIPULATE THE VALUES INSIDE THIS ARRAY!!!
	 *  
	 *  Just set this variable to another different Array instead.
	 *  Otherwise some colored things will get Problems.
	 */
	public short[] mRGBa;
	
	private final boolean mAllowAlpha, mUseMaxBrightness, mUseConstantBrightness;
	
	public BlockTextureCopied(Block aBlock, int aSide, int aMeta, short[] aRGBa, boolean aAllowAlpha, boolean aUseMaxBrightness, boolean aUseConstantBrightness) {
		if (aRGBa.length != 4) throw new IllegalArgumentException("RGBa doesn't have 4 Values @ BlockTextureCopied");
		mBlock = aBlock;
		mRGBa = aRGBa;
		mSide = (byte)aSide;
		mMeta = (byte)aMeta;
		mAllowAlpha = aAllowAlpha;
		mUseMaxBrightness = aUseMaxBrightness;
		mUseConstantBrightness = aUseConstantBrightness;
	}
	
	public BlockTextureCopied(Block aBlock, int aSide, int aMeta) {
		this(aBlock, aSide, aMeta, UNCOLOURED, false, false, false);
	}
	
	private IIcon getIcon(int aSide) {
		if (mSide == 6) return mBlock.getIcon(aSide, mMeta);
		return mBlock.getIcon(mSide, mMeta);
	}
	
	@Override
	public void renderXPos(RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, int aBrightness) {
    	ITexture.Util.renderXPos(getIcon(5), mRGBa, mAllowAlpha, mUseConstantBrightness, aRenderer, aBlock, aX, aY, aZ, mUseMaxBrightness?240:aBrightness);
	}
	
	@Override
	public void renderXNeg(RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, int aBrightness) {
	    ITexture.Util.renderXNeg(getIcon(4), mRGBa, mAllowAlpha, mUseConstantBrightness, aRenderer, aBlock, aX, aY, aZ, mUseMaxBrightness?240:aBrightness);
	}
	
	@Override
	public void renderYPos(RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, int aBrightness) {
	    ITexture.Util.renderYPos(getIcon(1), mRGBa, mAllowAlpha, mUseConstantBrightness, aRenderer, aBlock, aX, aY, aZ, mUseMaxBrightness?240:aBrightness);
	}
	
	@Override
	public void renderYNeg(RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, int aBrightness) {
	    ITexture.Util.renderYNeg(getIcon(0), mRGBa, mAllowAlpha, mUseConstantBrightness, aRenderer, aBlock, aX, aY, aZ, mUseMaxBrightness?240:aBrightness);
	}
	
	@Override
	public void renderZPos(RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, int aBrightness) {
	    ITexture.Util.renderZPos(getIcon(3), mRGBa, mAllowAlpha, mUseConstantBrightness, aRenderer, aBlock, aX, aY, aZ, mUseMaxBrightness?240:aBrightness);
	}
	
	@Override
	public void renderZNeg(RenderBlocks aRenderer, Block aBlock, int aX, int aY, int aZ, int aBrightness) {
	    ITexture.Util.renderZNeg(getIcon(2), mRGBa, mAllowAlpha, mUseConstantBrightness, aRenderer, aBlock, aX, aY, aZ, mUseMaxBrightness?240:aBrightness);
	}
	
	@Override
	public boolean isValidTexture() {
		return mBlock != null;
	}
}